# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchFlexTemplateParameter do
  @moduledoc """
  Launch Flex Template parameter.

  ## Attributes

  *   `containerSpecGcsPath` (*type:* `String.t`, *default:* `nil`) - Cloud Storage path to a file with a JSON-serialized ContainerSpec as content.
  *   `environment` (*type:* `GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1FlexTemplateRuntimeEnvironment.t`, *default:* `nil`) - The runtime environment for the Flex Template job.
  *   `jobName` (*type:* `String.t`, *default:* `nil`) - Required. The job name to use for the created job. For an update job request, the job name should be the same as the existing running job.
  *   `launchOptions` (*type:* `map()`, *default:* `nil`) - Launch options for this Flex Template job. This is a common set of options across languages and templates. This should not be used to pass job parameters.
  *   `parameters` (*type:* `map()`, *default:* `nil`) - The parameters for the Flex Template. Example: `{"num_workers":"5"}`
  *   `transformNameMappings` (*type:* `map()`, *default:* `nil`) - Use this to pass transform name mappings for streaming update jobs. Example: `{"oldTransformName":"newTransformName",...}`
  *   `update` (*type:* `boolean()`, *default:* `nil`) - Set this to true if you are sending a request to update a running streaming job. When set, the job name should be the same as the running job.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :containerSpecGcsPath => String.t() | nil,
          :environment =>
            GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1FlexTemplateRuntimeEnvironment.t()
            | nil,
          :jobName => String.t() | nil,
          :launchOptions => map() | nil,
          :parameters => map() | nil,
          :transformNameMappings => map() | nil,
          :update => boolean() | nil
        }

  field(:containerSpecGcsPath)

  field(:environment,
    as: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1FlexTemplateRuntimeEnvironment
  )

  field(:jobName)
  field(:launchOptions, type: :map)
  field(:parameters, type: :map)
  field(:transformNameMappings, type: :map)
  field(:update)
end

defimpl Poison.Decoder,
  for: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchFlexTemplateParameter do
  def decode(value, options) do
    GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchFlexTemplateParameter.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchFlexTemplateParameter do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
