# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1ScheduleSpec do
  @moduledoc """
  Details of the schedule the pipeline runs on.

  ## Attributes

  *   `nextJobTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. When the next Scheduler job is going to run.
  *   `schedule` (*type:* `String.t`, *default:* `nil`) - Unix-cron format of the schedule. This information is retrieved from the linked Cloud Scheduler.
  *   `timeZone` (*type:* `String.t`, *default:* `nil`) - Timezone ID. This matches the timezone IDs used by the Cloud Scheduler API. If empty, UTC time is assumed.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :nextJobTime => DateTime.t() | nil,
          :schedule => String.t() | nil,
          :timeZone => String.t() | nil
        }

  field(:nextJobTime, as: DateTime)
  field(:schedule)
  field(:timeZone)
end

defimpl Poison.Decoder,
  for: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1ScheduleSpec do
  def decode(value, options) do
    GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1ScheduleSpec.decode(value, options)
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1ScheduleSpec do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
