# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1Workload do
  @moduledoc """
  Workload details for creating the pipeline jobs.

  ## Attributes

  *   `dataflowFlexTemplateRequest` (*type:* `GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchFlexTemplateRequest.t`, *default:* `nil`) - Template information and additional parameters needed to launch a Dataflow job using the flex launch API.
  *   `dataflowLaunchTemplateRequest` (*type:* `GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchTemplateRequest.t`, *default:* `nil`) - Template information and additional parameters needed to launch a Dataflow job using the standard launch API.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :dataflowFlexTemplateRequest =>
            GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchFlexTemplateRequest.t()
            | nil,
          :dataflowLaunchTemplateRequest =>
            GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchTemplateRequest.t()
            | nil
        }

  field(:dataflowFlexTemplateRequest,
    as: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchFlexTemplateRequest
  )

  field(:dataflowLaunchTemplateRequest,
    as: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1LaunchTemplateRequest
  )
end

defimpl Poison.Decoder, for: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1Workload do
  def decode(value, options) do
    GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1Workload.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataPipelines.V1.Model.GoogleCloudDatapipelinesV1Workload do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
